<?php
/**
 * Ich bin die Sammelstelle für die Produkte.
 *
 */
class Catalogue {
	var $products, $dataFile, $fh,$cf, $separator, $categories, $category_for_the_left_overs, $default_category;
	function Catalogue($separator) {
		global $pth,$sl;
		$this -> dataFile = $pth['folder']['plugins']."wellrad".'/data/catalogue.inc';
		$this -> separator = $separator;
		$this -> load();
	}


	function load() {
		global $sl;
		 $temp = implode("",file($this -> dataFile));
		$temp = unserialize($temp);
			$i = 0;
			foreach($temp->products as $product) {
			if($product -> separator <> $this -> separator) {
				$new_links = array();
					foreach($product -> productPages[$sl] as $page) {
							$new_links[] = str_replace($product -> separator, $this -> separator, $page);
						}
						$product -> productPages[$sl] = $new_links;
					}
					$i++;
					$product -> counter = $i;
					$product -> separator = $this -> separator;
					$this->products[$i] = $product;

			}

			$this->categories = $temp->categories;
			$this -> category_for_the_left_overs = $temp -> category_for_the_left_overs;
			$this -> default_category = $temp -> default_category;
	}

	function save() {

		$temp = $this->products;
		foreach($temp as $product) {
			if(is_a($product, 'Product')){
				$product -> separator = $this -> separator;
				$products[]=$product;
			}
		}
		$this -> fh = fopen($this -> dataFile, "w+") or die("konnte nicht �ffnen");
		$this->products = $products;
		$temp = serialize($this);
		fwrite($this->fh, $temp) or die("konnte nicht schreiben");
		fclose($this->fh);
		$this->load();
	}

function rename_category($language, $category_index, $new_name) {
	$name = $this -> categories[$language][$category_index];
	foreach($this -> products as $product) {
		if(in_array($name, $product -> categories[$language])) {
			$new_categories = array();
			foreach($product -> categories[$language] as $kat) {
				if($kat == $name) {
					$kat = $new_name;
				}
				$new_categories[] = $kat;
			}
			$product -> categories[$language] = $new_categories;
		}
	}
	$this -> categories[$language][$category_index] = $new_name;
	$this -> save();


}

function delete_category($language, $category_index) {
	$name = $this -> categories[$language][$category_index];
	foreach($this -> products as $product) {
		if(in_array($name, $product -> categories[$language])) {
			$i = 0;
			$new_categories = array();
			foreach($product -> categories[$language] as $kat) {
				if($kat <> $name) {
					$new_categories[] = $kat;
				}
			$product -> categories[$language] = $new_categories;
			}
		}
	}
	unset($this -> categories[$language][$category_index]);
	$categories = array();
	foreach($this -> categories[$language] as $category){
		$categories[] = $category;
	}

	$this ->  categories[$language] = $categories;
		$this -> save();
}

	function add_category($language, $name) {
	}
	function set_left_over_category(){
	}
}
?>