<?php
class Product {
	var $counter,$names, $descriptions, $price, $linkedPages,$previewPicture,$vat,$separator, $categories, $stock_on_hand;
	function Product() {
		$this -> names = array();
		$this -> descriptions = array();
		$this -> productPages = array();
		$this -> categories = array();

	}

	function get_netto($rate_full, $rate_reduced){
		$netto = 0;
		$factor = 100;
		if($this->vat == 'full'){
			$factor = $factor+$rate_full;
		}
		if($this->vat == 'reduced') {
			$factor = $factor + $rate_reduced;
		}
		$netto = ($this->price/$factor)*100;
		return $netto;
	}

	function get_brutto(){
		return $this->price;
	}

	function get_included_tax($rate_full, $rate_reduced){
		return $this->price - $this->get_netto($rate_full, $rate_reduced);
	}


	function present_yourself_for_admins_table($sl, $button_image_folder, $products_count, $labels, $index_on_page, $currency,$writer){
		$name = $this -> get_the_name($sl);
		$description = $this -> get_the_description($sl);
		$image = $this -> get_the_preview_picture($sl);
		$link = $this -> get_the_details_link($sl, $labels['product_info']);
		$return .= $this -> create_move_product_cell($products_count, $button_image_folder, $index_on_page);
		$return .= $this -> create_product_info_cell($sl,$labels,$currency,$writer);
		$return .= $this -> create_edit_product_cell($button_image_folder);
		return $return;
	}
	function create_move_product_cell($products_count, $buttonImageFolder, $index_on_page) {
		$return = "\n\t<td style=\"vertical-align: top\"><br /><br />";
		$index = $index_on_page;
		if(($index) > 1){
			$return .= "\n\t<form style=\"display: inline\" action = \"".$_SERVER['REQUEST_URI']."#".($this->counter-1)."\" method=\"post\">";
			$return .= "\n\t\t<input type=\"hidden\" name = \"chosen_category\" value = \"".$_POST['chosen_category']. "\">";
			$return .= "\n\t\t<input type=\"hidden\" name = \"counter\" value = \"".$this -> counter. "\">";
			$return .= "\n\t\t<input type=\"hidden\" name = \"index_on_page\" value = \"".$index. "\">";
			$return .= "\n\t\t<input type= \"hidden\" name = \"task\" value = \"move_product_up\">";
			$return .= "\n\t\t<input class=\"image_button\" type=\"image\"  alt=\"move up button\"  title=\"move product up\" src=\"".$buttonImageFolder."uparrow.gif\" />\n\t</form>";
		}else {$return .= "<br />";}
		if($index < $products_count){
			$return .= "\n\t<form style=\"display: inline\" action = \"#".($this->counter+1)."\" method=\"post\">";
			$return .= "\n\t\t<input type=\"hidden\" name = \"chosen_category\" value = \"".$_POST['chosen_category']. "\">";
			$return .= "\n\t\t<input type=\"hidden\" name = \"index_on_page\" value = \"".$index. "\">";
			$return .= "\n\t\t<input type=\"hidden\" name = \"counter\" value = \"".$this -> counter. "\">";
			$return .= "\n\t\t<input type= \"hidden\" name = \"task\" value = \"move_product_down\" />";
			$return .= "\n\t\t<input class=\"image_button\" type=\"image\"  alt=\"move down button\"  title=\"move product down\" src=\"".$buttonImageFolder."downarrow.gif\" />\n\t</form>";
		}
		$return .= "\n\t</td>";
		return $return;
	}
	function create_product_info_cell($lang,$labels,$currency,$writer) {
		global $pth;

		$return .= "\n\t<td style=\"border-bottom: 1px black solid;\"><a name=\"".$this->counter."\"></a>";
		$return .= "\n\t<div class=\"productTitle\"><b>".$this -> names[$lang] ."</b></div>";
		if((isset($this->previewPicture)) && ($this->previewPicture <> '')) {
			$return .= "<img style=\"float: left; margin-right: 5px;\" src=\"".$pth['folder']['images'].$this->previewPicture."\" alt=\"$name - Cover\"  title=\"$name\"/>";
		}
		$return .= "\n\t<div class=\"productDescription\"><p>".nl2br(stripslashes($this -> descriptions[$lang]))."<br /></p></div>" ;
		foreach($this->productPages[$lang] as $page){
			$page = "x".$page; //warum auch immer, aber sonst wird das Fragezeichen an erster Stelle �bersehen
			$page = str_replace("_", " " ,$page);
			$position = 0;
			if(!$position){
				$position = strpos($page, '?');
			}
			if($position) {
				$page = substr_replace($page,"", 0,($position+1));
			}
			$page = urldecode($page);
			$page = str_replace($this -> separator, " -> ", $page);
			$pageLinks .= "\n\t\t<li>".$page ."</li>";
		}
		$categories = "\n\t<ul>";
		foreach($this->categories[$lang] as $category){
			$categories .= "\n\t\t<li>".$category ."</li>";
		}
		$return .= "\n\t<p><b>".$labels['product_categories']."</b>\n\t$categories\n\t</ul>\n\t</p>\n";
		$return .= "\n\t<p><b>".$labels['internal_link']."</b>\n\t<ul>$pageLinks\n\t</ul>\n\t</p>\n";
		$return .= "\n\t<p><b>".$labels['price'].":</b>&nbsp;&nbsp;".$writer->format_the_money($this -> price)."&nbsp;".$currency."</p>";
		$return .= "\n\t<p><b>".$labels['vat_rate'].":</b>&nbsp;&nbsp;".$labels[$this -> vat.'_vat']."</p>";
		$return .= "</td>";
		return $return;
	}
	function create_edit_product_cell($buttonImageFolder) {
		$return = "\n\t<td style=\"white-space: nowrap; background-color: #d0d0d0; padding: 2px; vertical-align: top; border-bottom: black 1px solid;\">";
		$return .= "\n\t<form style=\"display: inline\" action = \"\" method=\"post\"><input type= \"hidden\" name = \"counter\" value = \"".$this -> counter. "\" />";
		$return .= "\n\t\t<input type= \"hidden\" name = \"task\" value = \"edit_product\" />";
		$return .= "\n\t\t<input class=\"image_button\" type=\"image\"  alt=\"edit\"  title=\"edit product\" src=\"".$buttonImageFolder."edit_f2.gif\" /></form>";
		$return .= "\n\t<form style=\"display: inline\" action = \"\" method=\"post\"><input type= \"hidden\" name = \"counter\" value = \"".$this -> counter. "\">";
		$return .= "\n\t\t<input type= \"hidden\" name = \"task\" value = \"delete_product\" />";
		$return .= "\n\t\t<input class=\"image_button\" type=\"image\"  alt=\"delete\"  title=\"delete product\" src=\"".$buttonImageFolder."trash.gif\" />" ;
		$return .=	"\n\t</form></td>";
		return $return;
	}
	function get_the_name ($sl) {
		$name = $this ->names[$sl];
		if(!isset($this ->names[$sl])) {
			$langs = array_keys($this -> names);
			$lang = $langs[0];
			$name = $this -> names[$lang];
		}
	 return $name;
	}
	function get_the_description($sl) {
		$description = $this -> descriptions[$sl];
		$langs = array_keys($this -> descriptions);
		$lang = $langs[0];
		if(!isset($this ->descriptions[$sl])) {
			$description = $this -> descriptions[$lang];
		}
		return $description;
	}
	function get_the_preview_picture() {
		global $pth,$sl;
		if((isset($this->previewPicture)) && ($this->previewPicture <> '')) {
			$image = "<img src=\"".$pth['folder']['images'].$this->previewPicture."\" alt=\"".$this ->names[$sl] ." - Preview\"  title=\"$name\"/>";
		}
		return $image;
	}
	function get_the_details_link($sl, $info_label) {
		$link = '';
		if((isset($this -> productPages[$sl][0])) && ($this -> productPages[$sl][0]<>'')) {
			$name = "<a href=\"" . $this -> productPages[$sl][0] . "\">$name</a>";
			$link = "<a href=\"" . $this -> productPages[$sl][0] . "\"><b>".$info_label."</b></a>";
		}
		return $link;
	}

	function create_table_row_for_cart($lang,$anzahl, $css_class, $shop_url, $currency,$writer){
		if(!isset($this ->names[$lang])) {
			$langs = array_keys($this -> names);
			$lang = $langs[0];
		}
		$name = $this -> names[$lang];
		if((isset($this -> productPages[$lang])) && (count($this -> productPages[$lang])> 0)) {
			$name = "<a href=\"" . $this -> productPages[$lang][0] . "\">$name</a>";
		}
		$return = "\n\t<tr class=\"$css_class\">\n\t\t<td>";
		$return .="\n\t\t<form action=\"$shop_url\" method=\"post\" style=\"text-align: right;\">";
		$return .= 	"\n\t\t<input type=\"text\" size=\"1\"  name=\"amount\" value=\"".$anzahl ."\" onChange	=\"this.parentNode.submit()\" />";
		$return .= "<input type=\"submit\" value=\"ok!\" class=\"shopButton\" />";
		$return .= 	"\n\t\t<input type=\"hidden\"  name=\"task\" value=\"add_to_cart\" />";
		$return .= 	"\n\t\t<input type=\"hidden\"  name=\"order_step\" value=\"offer_to_order\" />";
		$return .= 	"\n\t\t<input type=\"hidden\"  name=\"cart_item\" value=\"".$this -> counter."\" />";
		$return .= "</form></td>";
		$return .= "\n\t\t<td style =\"text-align: right; white-space: nowrap;padding-right: 1em;\">".$name."</td>";
		$return .= "\n\t\t<td style =\"text-align: right; white-space: nowrap;padding-right: 1em;\">&agrave; ".  $writer->format_the_money($this -> price) ."&nbsp;".$this -> settings['default_currency']."</td>";
		$return.= "\n\t\t<td style =\"text-align: right;font-weight: bold;\">".  $writer->format_the_money($this -> price * $anzahl) . "&nbsp;".$currency."</td></tr>";
		return $return;
	}
}
?>